require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PARISC_DMA_MAPPING_H)) {
    eval 'sub _PARISC_DMA_MAPPING_H () {1;}' unless defined(&_PARISC_DMA_MAPPING_H);
    require 'linux/mm.ph';
    require 'linux/config.ph';
    require 'asm/cacheflush.ph';
    require 'asm/scatterlist.ph';
    if(defined(&CONFIG_PA11)) {
    }
    eval 'sub dma_alloc_coherent {
        my($dev,$size,$dma_handle,$flag) = @_;
	    eval q({  ($hppa_dma_ops->{alloc_consistent})($dev, $size, $dma_handle, $flag); });
    }' unless defined(&dma_alloc_coherent);
    eval 'sub dma_alloc_noncoherent {
        my($dev,$size,$dma_handle,$flag) = @_;
	    eval q({  ($hppa_dma_ops->{alloc_noncoherent})($dev, $size, $dma_handle, $flag); });
    }' unless defined(&dma_alloc_noncoherent);
    eval 'sub dma_free_coherent {
        my($dev,$size,$vaddr,$dma_handle) = @_;
	    eval q({  ($hppa_dma_ops->{free_consistent})($dev, $size, $vaddr, $dma_handle); });
    }' unless defined(&dma_free_coherent);
    eval 'sub dma_free_noncoherent {
        my($dev,$size,$vaddr,$dma_handle) = @_;
	    eval q({  ($hppa_dma_ops->{free_consistent})($dev, $size, $vaddr, $dma_handle); });
    }' unless defined(&dma_free_noncoherent);
    eval 'sub dma_map_single {
        my($dev,$ptr,$size,$direction) = @_;
	    eval q({  ($hppa_dma_ops->{map_single})($dev, $ptr, $size, $direction); });
    }' unless defined(&dma_map_single);
    eval 'sub dma_unmap_single {
        my($dev,$dma_addr,$size,$direction) = @_;
	    eval q({  ($hppa_dma_ops->{unmap_single})($dev, $dma_addr, $size, $direction); });
    }' unless defined(&dma_unmap_single);
    eval 'sub dma_map_sg {
        my($dev,$sg,$nents,$direction) = @_;
	    eval q({  ($hppa_dma_ops->{map_sg})($dev, $sg, $nents, $direction); });
    }' unless defined(&dma_map_sg);
    eval 'sub dma_unmap_sg {
        my($dev,$sg,$nhwentries,$direction) = @_;
	    eval q({  ($hppa_dma_ops->{unmap_sg})($dev, $sg, $nhwentries, $direction); });
    }' unless defined(&dma_unmap_sg);
    eval 'sub dma_map_page {
        my($dev,$page,$offset,$size,$direction) = @_;
	    eval q({  &dma_map_single($dev, ( &page_address($page) + ($offset)), $size, $direction); });
    }' unless defined(&dma_map_page);
    eval 'sub dma_unmap_page {
        my($dev,$dma_address,$size,$direction) = @_;
	    eval q({  &dma_unmap_single($dev, $dma_address, $size, $direction); });
    }' unless defined(&dma_unmap_page);
    eval 'sub dma_sync_single_for_cpu {
        my($dev,$dma_handle,$size,$direction) = @_;
	    eval q({  &if( ($hppa_dma_ops->{dma_sync_single_for_cpu}))  ($hppa_dma_ops->{dma_sync_single_for_cpu})($dev, $dma_handle, 0, $size, $direction); });
    }' unless defined(&dma_sync_single_for_cpu);
    eval 'sub dma_sync_single_for_device {
        my($dev,$dma_handle,$size,$direction) = @_;
	    eval q({  &if( ($hppa_dma_ops->{dma_sync_single_for_device}))  ($hppa_dma_ops->{dma_sync_single_for_device})($dev, $dma_handle, 0, $size, $direction); });
    }' unless defined(&dma_sync_single_for_device);
    eval 'sub dma_sync_single_range_for_cpu {
        my($dev,$dma_handle,$offset,$size,$direction) = @_;
	    eval q({  &if( ($hppa_dma_ops->{dma_sync_single_for_cpu}))  ($hppa_dma_ops->{dma_sync_single_for_cpu})($dev, $dma_handle, $offset, $size, $direction); });
    }' unless defined(&dma_sync_single_range_for_cpu);
    eval 'sub dma_sync_single_range_for_device {
        my($dev,$dma_handle,$offset,$size,$direction) = @_;
	    eval q({  &if( ($hppa_dma_ops->{dma_sync_single_for_device}))  ($hppa_dma_ops->{dma_sync_single_for_device})($dev, $dma_handle, $offset, $size, $direction); });
    }' unless defined(&dma_sync_single_range_for_device);
    eval 'sub dma_sync_sg_for_cpu {
        my($dev,$sg,$nelems,$direction) = @_;
	    eval q({  &if( ($hppa_dma_ops->{dma_sync_sg_for_cpu}))  ($hppa_dma_ops->{dma_sync_sg_for_cpu})($dev, $sg, $nelems, $direction); });
    }' unless defined(&dma_sync_sg_for_cpu);
    eval 'sub dma_sync_sg_for_device {
        my($dev,$sg,$nelems,$direction) = @_;
	    eval q({  &if( ($hppa_dma_ops->{dma_sync_sg_for_device}))  ($hppa_dma_ops->{dma_sync_sg_for_device})($dev, $sg, $nelems, $direction); });
    }' unless defined(&dma_sync_sg_for_device);
    eval 'sub dma_supported {
        my($dev,$mask) = @_;
	    eval q({  ($hppa_dma_ops->{dma_supported})($dev, $mask); });
    }' unless defined(&dma_supported);
    eval 'sub dma_set_mask {
        my($dev,$mask) = @_;
	    eval q({  &if(! ($dev->{dma_mask}) || ! &dma_supported($dev, $mask)) - &EIO; * ($dev->{dma_mask}) = $mask; 0; });
    }' unless defined(&dma_set_mask);
    eval 'sub dma_get_cache_alignment {
        my($void) = @_;
	    eval q({  &dcache_stride; });
    }' unless defined(&dma_get_cache_alignment);
    eval 'sub dma_is_consistent {
        my($dma_addr) = @_;
	    eval q({ ( ($hppa_dma_ops->{dma_sync_single_for_cpu}) ==  &NULL); });
    }' unless defined(&dma_is_consistent);
    eval 'sub dma_cache_sync {
        my($vaddr,$size,$direction) = @_;
	    eval q({  &if( ($hppa_dma_ops->{dma_sync_single_for_cpu}))  &flush_kernel_dcache_range($vaddr, $size); });
    }' unless defined(&dma_cache_sync);
    eval 'sub parisc_walk_tree {
        my($dev) = @_;
	    eval q({ \'struct device\' * &otherdev;  &if( &likely( ($dev->{platform_data}) !=  &NULL))  ($dev->{platform_data});  &for( &otherdev =  ($dev->{parent});  &otherdev;  &otherdev =  ($otherdev->{parent})) {  &if( ($otherdev->{platform_data})) {  ($dev->{platform_data}) =  ($otherdev->{platform_data});  &break; } }  &BUG_ON(! ($dev->{platform_data}));  ($dev->{platform_data}); });
    }' unless defined(&parisc_walk_tree);
    eval 'sub GET_IOC {
        my($dev) = @_;
	    eval q(( &HBA_DATA( &parisc_walk_tree($dev))-> &iommu););
    }' unless defined(&GET_IOC);
    if(defined(&CONFIG_IOMMU_CCIO)) {
    } else {
	eval 'sub ccio_get_iommu {
	    my($dev) = @_;
    	    eval q( &NULL);
	}' unless defined(&ccio_get_iommu);
	eval 'sub ccio_request_resource {
	    my($dev, $res) = @_;
    	    eval q( &request_resource( &iomem_resource, $res));
	}' unless defined(&ccio_request_resource);
	eval 'sub ccio_allocate_resource {
	    my($dev, $res, $size, $min, $max, $align) = @_;
    	    eval q( &allocate_resource( &iomem_resource, $res, $size, $min, $max, $align,  &NULL,  &NULL));
	}' unless defined(&ccio_allocate_resource);
    }
    if(defined(&CONFIG_IOMMU_SBA)) {
    }
    eval 'sub dma_mapping_error {
        my($x) = @_;
	    eval q(0);
    }' unless defined(&dma_mapping_error);
}
1;
