require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IO_H)) {
    eval 'sub _ASM_IO_H () {1;}' unless defined(&_ASM_IO_H);
    require 'linux/config.ph';
    require 'linux/types.ph';
    require 'asm/pgtable.ph';
    eval 'sub BIO_VMERGE_BOUNDARY () { &parisc_vmerge_boundary;}' unless defined(&BIO_VMERGE_BOUNDARY);
    eval 'sub BIO_VMERGE_MAX_SIZE () { &parisc_vmerge_max_size;}' unless defined(&BIO_VMERGE_MAX_SIZE);
    eval 'sub virt_to_phys {
        my($a) = @_;
	    eval q(( &__pa($a)));
    }' unless defined(&virt_to_phys);
    eval 'sub phys_to_virt {
        my($a) = @_;
	    eval q( &__va($a));
    }' unless defined(&phys_to_virt);
    eval 'sub virt_to_bus () { &virt_to_phys;}' unless defined(&virt_to_bus);
    eval 'sub bus_to_virt () { &phys_to_virt;}' unless defined(&bus_to_virt);
    if(defined(&CONFIG_DEBUG_IOREMAP)) {
	if(defined(&CONFIG_64BIT)) {
	    eval 'sub NYBBLE_SHIFT () {60;}' unless defined(&NYBBLE_SHIFT);
	} else {
	    eval 'sub NYBBLE_SHIFT () {28;}' unless defined(&NYBBLE_SHIFT);
	}
	eval 'sub gsc_check_addr {
	    my($addr) = @_;
    	    eval q( &if (($addr >>  &NYBBLE_SHIFT) != 0xf) {  &gsc_bad_addr($addr); $addr |= 0xf <<  &NYBBLE_SHIFT; });
	}' unless defined(&gsc_check_addr);
	eval 'sub __raw_check_addr {
	    my($addr) = @_;
    	    eval q( &if (($addr >>  &NYBBLE_SHIFT) != 0xe)  &__raw_bad_addr($addr); $addr = ( &void *)($addr | (0xf <<  &NYBBLE_SHIFT)););
	}' unless defined(&__raw_check_addr);
    } else {
	eval 'sub gsc_check_addr {
	    my($addr) = @_;
    	    eval q();
	}' unless defined(&gsc_check_addr);
	eval 'sub __raw_check_addr {
	    my($addr) = @_;
    	    eval q();
	}' unless defined(&__raw_check_addr);
    }
    eval 'sub gsc_readb {
        my($addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&gsc_readb);
    eval 'sub gsc_readw {
        my($addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&gsc_readw);
    eval 'sub gsc_readl {
        my($addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&gsc_readl);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub gsc_readq {
        my($addr) = @_;
	    eval q({ my $ret;  &gsc_check_addr($addr);  $ret; });
    }' unless defined(&gsc_readq);
    eval 'sub gsc_writeb {
        my($val,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&gsc_writeb);
    eval 'sub gsc_writew {
        my($val,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&gsc_writew);
    eval 'sub gsc_writel {
        my($val,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&gsc_writel);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub gsc_writeq {
        my($val,$addr) = @_;
	    eval q({  &gsc_check_addr($addr); });
    }' unless defined(&gsc_writeq);
    eval 'sub USE_HPPA_IOREMAP () {0;}' unless defined(&USE_HPPA_IOREMAP);
    if((defined(&USE_HPPA_IOREMAP) ? &USE_HPPA_IOREMAP : 0)) {
	eval 'sub __raw_readb {
	    my($addr) = @_;
    	    eval q({ (*( &volatile my $__force *) ($addr)); });
	}' unless defined(&__raw_readb);
	eval 'sub __raw_readw {
	    my($addr) = @_;
    	    eval q({ *( &volatile my $__force *) $addr; });
	}' unless defined(&__raw_readw);
	eval 'sub __raw_readl {
	    my($addr) = @_;
    	    eval q({ *( &volatile my $__force *) $addr; });
	}' unless defined(&__raw_readl);
	eval 'sub __raw_readq {
	    my($addr) = @_;
    	    eval q({ *( &volatile my $__force *) $addr; });
	}' unless defined(&__raw_readq);
	eval 'sub __raw_writeb {
	    my($b,$addr) = @_;
    	    eval q({ *( &volatile my $__force *) $addr = $b; });
	}' unless defined(&__raw_writeb);
	eval 'sub __raw_writew {
	    my($b,$addr) = @_;
    	    eval q({ *( &volatile my $__force *) $addr = $b; });
	}' unless defined(&__raw_writew);
	eval 'sub __raw_writel {
	    my($b,$addr) = @_;
    	    eval q({ *( &volatile my $__force *) $addr = $b; });
	}' unless defined(&__raw_writel);
	eval 'sub __raw_writeq {
	    my($b,$addr) = @_;
    	    eval q({ *( &volatile my $__force *) $addr = $b; });
	}' unless defined(&__raw_writeq);
    } else {
	eval 'sub __raw_readb {
	    my($addr) = @_;
    	    eval q({  &__raw_check_addr($addr);  &gsc_readb( $addr); });
	}' unless defined(&__raw_readb);
	eval 'sub __raw_readw {
	    my($addr) = @_;
    	    eval q({  &__raw_check_addr($addr);  &gsc_readw( $addr); });
	}' unless defined(&__raw_readw);
	eval 'sub __raw_readl {
	    my($addr) = @_;
    	    eval q({  &__raw_check_addr($addr);  &gsc_readl( $addr); });
	}' unless defined(&__raw_readl);
	eval 'sub __raw_readq {
	    my($addr) = @_;
    	    eval q({  &__raw_check_addr($addr);  &gsc_readq( $addr); });
	}' unless defined(&__raw_readq);
	eval 'sub __raw_writeb {
	    my($b,$addr) = @_;
    	    eval q({  &__raw_check_addr($addr);  &gsc_writeb($b,  $addr); });
	}' unless defined(&__raw_writeb);
	eval 'sub __raw_writew {
	    my($b,$addr) = @_;
    	    eval q({  &__raw_check_addr($addr);  &gsc_writew($b,  $addr); });
	}' unless defined(&__raw_writew);
	eval 'sub __raw_writel {
	    my($b,$addr) = @_;
    	    eval q({  &__raw_check_addr($addr);  &gsc_writel($b,  $addr); });
	}' unless defined(&__raw_writel);
	eval 'sub __raw_writeq {
	    my($b,$addr) = @_;
    	    eval q({  &__raw_check_addr($addr);  &gsc_writeq($b,  $addr); });
	}' unless defined(&__raw_writeq);
    }
    eval 'sub readb {
        my($addr) = @_;
	    eval q( &__raw_readb($addr));
    }' unless defined(&readb);
    eval 'sub readw {
        my($addr) = @_;
	    eval q( &le16_to_cpu( &__raw_readw($addr)));
    }' unless defined(&readw);
    eval 'sub readl {
        my($addr) = @_;
	    eval q( &le32_to_cpu( &__raw_readl($addr)));
    }' unless defined(&readl);
    eval 'sub readq {
        my($addr) = @_;
	    eval q( &le64_to_cpu( &__raw_readq($addr)));
    }' unless defined(&readq);
    eval 'sub writeb {
        my($b, $addr) = @_;
	    eval q( &__raw_writeb($b, $addr));
    }' unless defined(&writeb);
    eval 'sub writew {
        my($b, $addr) = @_;
	    eval q( &__raw_writew( &cpu_to_le16($b), $addr));
    }' unless defined(&writew);
    eval 'sub writel {
        my($b, $addr) = @_;
	    eval q( &__raw_writel( &cpu_to_le32($b), $addr));
    }' unless defined(&writel);
    eval 'sub writeq {
        my($b, $addr) = @_;
	    eval q( &__raw_writeq( &cpu_to_le64($b), $addr));
    }' unless defined(&writeq);
    eval 'sub readb_relaxed {
        my($addr) = @_;
	    eval q( &readb($addr));
    }' unless defined(&readb_relaxed);
    eval 'sub readw_relaxed {
        my($addr) = @_;
	    eval q( &readw($addr));
    }' unless defined(&readw_relaxed);
    eval 'sub readl_relaxed {
        my($addr) = @_;
	    eval q( &readl($addr));
    }' unless defined(&readl_relaxed);
    eval 'sub readq_relaxed {
        my($addr) = @_;
	    eval q( &readq($addr));
    }' unless defined(&readq_relaxed);
    eval 'sub mmiowb () {
        eval q( &do { }  &while (0));
    }' unless defined(&mmiowb);
    eval 'sub __isa_addr {
        my($x) = @_;
	    eval q(( &void  &__iomem *)( &F_EXTEND(0xfc000000) | ($x)));
    }' unless defined(&__isa_addr);
    eval 'sub isa_readb {
        my($a) = @_;
	    eval q( &readb( &__isa_addr($a)));
    }' unless defined(&isa_readb);
    eval 'sub isa_readw {
        my($a) = @_;
	    eval q( &readw( &__isa_addr($a)));
    }' unless defined(&isa_readw);
    eval 'sub isa_readl {
        my($a) = @_;
	    eval q( &readl( &__isa_addr($a)));
    }' unless defined(&isa_readl);
    eval 'sub isa_writeb {
        my($b,$a) = @_;
	    eval q( &writeb(($b),  &__isa_addr($a)));
    }' unless defined(&isa_writeb);
    eval 'sub isa_writew {
        my($b,$a) = @_;
	    eval q( &writew(($b),  &__isa_addr($a)));
    }' unless defined(&isa_writew);
    eval 'sub isa_writel {
        my($b,$a) = @_;
	    eval q( &writel(($b),  &__isa_addr($a)));
    }' unless defined(&isa_writel);
    eval 'sub isa_memset_io {
        my($a,$b,$c) = @_;
	    eval q( &memset_io( &__isa_addr($a), ($b), ($c)));
    }' unless defined(&isa_memset_io);
    eval 'sub isa_memcpy_fromio {
        my($a,$b,$c) = @_;
	    eval q( &memcpy_fromio(($a),  &__isa_addr($b), ($c)));
    }' unless defined(&isa_memcpy_fromio);
    eval 'sub isa_memcpy_toio {
        my($a,$b,$c) = @_;
	    eval q( &memcpy_toio( &__isa_addr($a), ($b), ($c)));
    }' unless defined(&isa_memcpy_toio);
    eval 'sub eth_io_copy_and_sum {
        my($skb,$src,$len,$unused) = @_;
	    eval q( &memcpy_fromio(($skb)-> &data,($src),($len)));
    }' unless defined(&eth_io_copy_and_sum);
    eval 'sub isa_eth_io_copy_and_sum {
        my($skb,$src,$len,$unused) = @_;
	    eval q( &isa_memcpy_fromio(($skb)-> &data,($src),($len)));
    }' unless defined(&isa_eth_io_copy_and_sum);
    eval 'sub inb_p () { &inb;}' unless defined(&inb_p);
    eval 'sub inw_p () { &inw;}' unless defined(&inw_p);
    eval 'sub inl_p () { &inl;}' unless defined(&inl_p);
    eval 'sub outb_p () { &outb;}' unless defined(&outb_p);
    eval 'sub outw_p () { &outw;}' unless defined(&outw_p);
    eval 'sub outl_p () { &outl;}' unless defined(&outl_p);
    if(defined( &CONFIG_PCI)) {
    }
 elsif(defined( &CONFIG_EISA)) {
	eval 'sub inb () { &eisa_in8;}' unless defined(&inb);
	eval 'sub inw () { &eisa_in16;}' unless defined(&inw);
	eval 'sub inl () { &eisa_in32;}' unless defined(&inl);
	eval 'sub outb () { &eisa_out8;}' unless defined(&outb);
	eval 'sub outw () { &eisa_out16;}' unless defined(&outw);
	eval 'sub outl () { &eisa_out32;}' unless defined(&outl);
    } else {
	eval 'sub inb {
	    my($addr) = @_;
    	    eval q({  &BUG(); -1; });
	}' unless defined(&inb);
	eval 'sub inw {
	    my($addr) = @_;
    	    eval q({  &BUG(); -1; });
	}' unless defined(&inw);
	eval 'sub inl {
	    my($addr) = @_;
    	    eval q({  &BUG(); -1; });
	}' unless defined(&inl);
	eval 'sub outb {
	    my($x, $y) = @_;
    	    eval q( &BUG());
	}' unless defined(&outb);
	eval 'sub outw {
	    my($x, $y) = @_;
    	    eval q( &BUG());
	}' unless defined(&outw);
	eval 'sub outl {
	    my($x, $y) = @_;
    	    eval q( &BUG());
	}' unless defined(&outl);
    }
    eval 'sub IO_SPACE_LIMIT () {0xffffff;}' unless defined(&IO_SPACE_LIMIT);
    eval 'sub dma_cache_inv {
        my($_start,$_size) = @_;
	    eval q( &do {  &flush_kernel_dcache_range($_start,$_size); }  &while (0));
    }' unless defined(&dma_cache_inv);
    eval 'sub dma_cache_wback {
        my($_start,$_size) = @_;
	    eval q( &do {  &flush_kernel_dcache_range($_start,$_size); }  &while (0));
    }' unless defined(&dma_cache_wback);
    eval 'sub dma_cache_wback_inv {
        my($_start,$_size) = @_;
	    eval q( &do {  &flush_kernel_dcache_range($_start,$_size); }  &while (0));
    }' unless defined(&dma_cache_wback_inv);
    eval 'sub F_EXTEND {
        my($x) = @_;
	    eval q(((($x) | (1.84467440694146e+19))));
    }' unless defined(&F_EXTEND);
    require 'asm-generic/iomap.ph';
}
1;
