require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_PARPORT_GSC_H)) {
    eval 'sub __LINUX_PARPORT_GSC_H () {1;}' unless defined(&__LINUX_PARPORT_GSC_H);
    require 'asm/io.ph';
    require 'linux/delay.ph';
    undef(&DEBUG_PARPORT) if defined(&DEBUG_PARPORT);
    eval 'sub DELAY_TIME () {0;}' unless defined(&DELAY_TIME);
    if((defined(&DELAY_TIME) ? &DELAY_TIME : 0) == 0) {
	eval 'sub parport_readb () { &gsc_readb;}' unless defined(&parport_readb);
	eval 'sub parport_writeb () { &gsc_writeb;}' unless defined(&parport_writeb);
    } else {
	eval 'sub parport_readb {
	    my($port) = @_;
    	    eval q({  &udelay( &DELAY_TIME);  &gsc_readb($port); });
	}' unless defined(&parport_readb);
	eval 'sub parport_writeb {
	    my($value,$port) = @_;
    	    eval q({  &gsc_writeb($value,$port);  &udelay( &DELAY_TIME); });
	}' unless defined(&parport_writeb);
    }
    eval 'sub EPPDATA {
        my($p) = @_;
	    eval q((($p)-> &base + 0x4));
    }' unless defined(&EPPDATA);
    eval 'sub EPPADDR {
        my($p) = @_;
	    eval q((($p)-> &base + 0x3));
    }' unless defined(&EPPADDR);
    eval 'sub CONTROL {
        my($p) = @_;
	    eval q((($p)-> &base + 0x2));
    }' unless defined(&CONTROL);
    eval 'sub STATUS {
        my($p) = @_;
	    eval q((($p)-> &base + 0x1));
    }' unless defined(&STATUS);
    eval 'sub DATA {
        my($p) = @_;
	    eval q((($p)-> &base + 0x));
    }' unless defined(&DATA);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub parport_gsc_write_data {
        my($p,$d) = @_;
	    eval q({  &parport_writeb($d,  &DATA($p)); });
    }' unless defined(&parport_gsc_write_data);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub parport_gsc_read_data {
        my($p) = @_;
	    eval q({ my $val =  &parport_readb ( &DATA ($p));  $val; });
    }' unless defined(&parport_gsc_read_data);
    if(defined(&DEBUG_PARPORT)) {
    }
    eval 'sub parport_gsc_data_reverse {
        my($p) = @_;
	    eval q({  &__parport_gsc_frob_control ($p, 0x20, 0x20); });
    }' unless defined(&parport_gsc_data_reverse);
    eval 'sub parport_gsc_data_forward {
        my($p) = @_;
	    eval q({  &__parport_gsc_frob_control ($p, 0x20, 0x); });
    }' unless defined(&parport_gsc_data_forward);
    eval 'sub parport_gsc_write_control {
        my($p,$d) = @_;
	    eval q({  &const my $wm = ( &PARPORT_CONTROL_STROBE |  &PARPORT_CONTROL_AUTOFD |  &PARPORT_CONTROL_INIT |  &PARPORT_CONTROL_SELECT);  &if ($d & 0x20) {  &printk ( &KERN_DEBUG \\"%s (%s): use data_reverse for this!\\\\n\\",  ($p->{name}),  ($p->{cad}->{name}));  &parport_gsc_data_reverse ($p); }  &__parport_gsc_frob_control ($p,  $wm, $d &  $wm); });
    }' unless defined(&parport_gsc_write_control);
    eval 'sub parport_gsc_read_control {
        my($p) = @_;
	    eval q({  &const my $rm = ( &PARPORT_CONTROL_STROBE |  &PARPORT_CONTROL_AUTOFD |  &PARPORT_CONTROL_INIT |  &PARPORT_CONTROL_SELECT);  &const \'struct parport_gsc_private\' * &priv =  ($p->{physport}->{private_data});  ($priv->{ctr}) &  $rm; });
    }' unless defined(&parport_gsc_read_control);
    eval 'sub parport_gsc_frob_control {
        my($p,$mask,$val) = @_;
	    eval q({  &const my $wm = ( &PARPORT_CONTROL_STROBE |  &PARPORT_CONTROL_AUTOFD |  &PARPORT_CONTROL_INIT |  &PARPORT_CONTROL_SELECT);  &if ($mask & 0x20) {  &printk ( &KERN_DEBUG \\"%s (%s): use data_%s for this!\\\\n\\",  ($p->{name}),  ($p->{cad}->{name}), ($val & 0x20) ? \\"reverse\\" : \\"forward\\");  &if ($val & 0x20)  &parport_gsc_data_reverse ($p);  &else  &parport_gsc_data_forward ($p); } $mask &=  $wm; $val &=  $wm;  &__parport_gsc_frob_control ($p, $mask, $val); });
    }' unless defined(&parport_gsc_frob_control);
    eval 'sub parport_gsc_read_status {
        my($p) = @_;
	    eval q({  &parport_readb ( &STATUS($p)); });
    }' unless defined(&parport_gsc_read_status);
    eval 'sub parport_gsc_disable_irq {
        my($p) = @_;
	    eval q({  &__parport_gsc_frob_control ($p, 0x10, 0x); });
    }' unless defined(&parport_gsc_disable_irq);
    eval 'sub parport_gsc_enable_irq {
        my($p) = @_;
	    eval q({  &__parport_gsc_frob_control ($p, 0x10, 0x10); });
    }' unless defined(&parport_gsc_enable_irq);
}
1;
