require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PARISC_PGTABLE_H)) {
    eval 'sub _PARISC_PGTABLE_H () {1;}' unless defined(&_PARISC_PGTABLE_H);
    require 'asm-generic/4level-fixup.ph';
    require 'linux/config.ph';
    require 'asm/fixmap.ph';
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/spinlock.ph';
	require 'asm/processor.ph';
	require 'asm/cache.ph';
	require 'asm/bitops.ph';
	eval 'sub kern_addr_valid {
	    my($addr) = @_;
    	    eval q((1));
	}' unless defined(&kern_addr_valid);
	eval 'sub set_pte {
	    my($pteptr, $pteval) = @_;
    	    eval q( &do{ *($pteptr) = ($pteval); }  &while(0));
	}' unless defined(&set_pte);
    }
    eval 'sub pte_ERROR {
        my($e) = @_;
	    eval q( &printk(\\"%s:%d: bad pte %08lx.\\\\n\\",  &__FILE__,  &__LINE__,  &pte_val($e)));
    }' unless defined(&pte_ERROR);
    eval 'sub pmd_ERROR {
        my($e) = @_;
	    eval q( &printk(\\"%s:%d: bad pmd %08lx.\\\\n\\",  &__FILE__,  &__LINE__,  &pmd_val($e)));
    }' unless defined(&pmd_ERROR);
    eval 'sub pgd_ERROR {
        my($e) = @_;
	    eval q( &printk(\\"%s:%d: bad pgd %08lx.\\\\n\\",  &__FILE__,  &__LINE__,  &pgd_val($e)));
    }' unless defined(&pgd_ERROR);
    eval 'sub ISTACK_SIZE () {32768;}' unless defined(&ISTACK_SIZE);
    eval 'sub ISTACK_ORDER () {3;}' unless defined(&ISTACK_ORDER);
    if(defined(&CONFIG_64BIT)) {
	eval 'sub KERNEL_INITIAL_ORDER () {24;}' unless defined(&KERNEL_INITIAL_ORDER);
    } else {
	eval 'sub KERNEL_INITIAL_ORDER () {23;}' unless defined(&KERNEL_INITIAL_ORDER);
    }
    eval 'sub KERNEL_INITIAL_SIZE () {(1<<  &KERNEL_INITIAL_ORDER);}' unless defined(&KERNEL_INITIAL_SIZE);
    if(defined(&CONFIG_64BIT)) {
	eval 'sub PT_NLEVELS () {3;}' unless defined(&PT_NLEVELS);
	eval 'sub PGD_ORDER () {1;}' unless defined(&PGD_ORDER);
	eval 'sub PMD_ORDER () {1;}' unless defined(&PMD_ORDER);
	eval 'sub PGD_ALLOC_ORDER () {2;}' unless defined(&PGD_ALLOC_ORDER);
    } else {
	eval 'sub PT_NLEVELS () {2;}' unless defined(&PT_NLEVELS);
	eval 'sub PGD_ORDER () {1;}' unless defined(&PGD_ORDER);
	eval 'sub PGD_ALLOC_ORDER () { &PGD_ORDER;}' unless defined(&PGD_ALLOC_ORDER);
    }
    eval 'sub PLD_SHIFT () { &PAGE_SHIFT;}' unless defined(&PLD_SHIFT);
    eval 'sub PLD_SIZE () { &PAGE_SIZE;}' unless defined(&PLD_SIZE);
    eval 'sub BITS_PER_PTE () {( &PAGE_SHIFT -  &BITS_PER_PTE_ENTRY);}' unless defined(&BITS_PER_PTE);
    eval 'sub PTRS_PER_PTE () {(1 <<  &BITS_PER_PTE);}' unless defined(&PTRS_PER_PTE);
    eval 'sub pgtable_cache_init () {
        eval q( &do { }  &while (0));
    }' unless defined(&pgtable_cache_init);
    eval 'sub PMD_SHIFT () {( &PLD_SHIFT +  &BITS_PER_PTE);}' unless defined(&PMD_SHIFT);
    eval 'sub PMD_SIZE () {(1 <<  &PMD_SHIFT);}' unless defined(&PMD_SIZE);
    eval 'sub PMD_MASK () {(~( &PMD_SIZE-1));}' unless defined(&PMD_MASK);
    if((defined(&PT_NLEVELS) ? &PT_NLEVELS : 0) == 3) {
	eval 'sub BITS_PER_PMD () {( &PAGE_SHIFT +  &PMD_ORDER -  &BITS_PER_PMD_ENTRY);}' unless defined(&BITS_PER_PMD);
    } else {
	eval 'sub BITS_PER_PMD () {0;}' unless defined(&BITS_PER_PMD);
    }
    eval 'sub PTRS_PER_PMD () {(1 <<  &BITS_PER_PMD);}' unless defined(&PTRS_PER_PMD);
    eval 'sub PGDIR_SHIFT () {( &PMD_SHIFT +  &BITS_PER_PMD);}' unless defined(&PGDIR_SHIFT);
    eval 'sub BITS_PER_PGD () {( &PAGE_SHIFT +  &PGD_ORDER -  &BITS_PER_PGD_ENTRY);}' unless defined(&BITS_PER_PGD);
    eval 'sub PGDIR_SIZE () {(1 <<  &PGDIR_SHIFT);}' unless defined(&PGDIR_SIZE);
    eval 'sub PGDIR_MASK () {(~( &PGDIR_SIZE-1));}' unless defined(&PGDIR_MASK);
    eval 'sub PTRS_PER_PGD () {(1 <<  &BITS_PER_PGD);}' unless defined(&PTRS_PER_PGD);
    eval 'sub USER_PTRS_PER_PGD () { &PTRS_PER_PGD;}' unless defined(&USER_PTRS_PER_PGD);
    eval 'sub MAX_ADDRBITS () {( &PGDIR_SHIFT +  &BITS_PER_PGD);}' unless defined(&MAX_ADDRBITS);
    eval 'sub MAX_ADDRESS () {(1 <<  &MAX_ADDRBITS);}' unless defined(&MAX_ADDRESS);
    eval 'sub SPACEID_SHIFT () {( &MAX_ADDRBITS - 32);}' unless defined(&SPACEID_SHIFT);
    eval 'sub PT_INITIAL () {(1<< ( &KERNEL_INITIAL_ORDER -  &PMD_SHIFT));}' unless defined(&PT_INITIAL);
    eval 'sub FIRST_USER_PGD_NR () {0;}' unless defined(&FIRST_USER_PGD_NR);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub PCXL_DMA_MAP_SIZE () {(8*1024*1024);}' unless defined(&PCXL_DMA_MAP_SIZE);
	eval 'sub VMALLOC_START () {( &vmalloc_start);}' unless defined(&VMALLOC_START);
	eval 'sub VMALLOC_END () {( &KERNEL_MAP_END);}' unless defined(&VMALLOC_END);
    }
    eval 'sub _PAGE_READ_BIT () {31;}' unless defined(&_PAGE_READ_BIT);
    eval 'sub _PAGE_WRITE_BIT () {30;}' unless defined(&_PAGE_WRITE_BIT);
    eval 'sub _PAGE_EXEC_BIT () {29;}' unless defined(&_PAGE_EXEC_BIT);
    eval 'sub _PAGE_GATEWAY_BIT () {28;}' unless defined(&_PAGE_GATEWAY_BIT);
    eval 'sub _PAGE_DMB_BIT () {27;}' unless defined(&_PAGE_DMB_BIT);
    eval 'sub _PAGE_DIRTY_BIT () {26;}' unless defined(&_PAGE_DIRTY_BIT);
    eval 'sub _PAGE_FILE_BIT () { &_PAGE_DIRTY_BIT;}' unless defined(&_PAGE_FILE_BIT);
    eval 'sub _PAGE_REFTRAP_BIT () {25;}' unless defined(&_PAGE_REFTRAP_BIT);
    eval 'sub _PAGE_NO_CACHE_BIT () {24;}' unless defined(&_PAGE_NO_CACHE_BIT);
    eval 'sub _PAGE_ACCESSED_BIT () {23;}' unless defined(&_PAGE_ACCESSED_BIT);
    eval 'sub _PAGE_PRESENT_BIT () {22;}' unless defined(&_PAGE_PRESENT_BIT);
    eval 'sub _PAGE_FLUSH_BIT () {21;}' unless defined(&_PAGE_FLUSH_BIT);
    eval 'sub _PAGE_USER_BIT () {20;}' unless defined(&_PAGE_USER_BIT);
    eval 'sub xlate_pabit {
        my($x) = @_;
	    eval q((31- $x));
    }' unless defined(&xlate_pabit);
    eval 'sub PTE_SHIFT () { &xlate_pabit( &_PAGE_USER_BIT);}' unless defined(&PTE_SHIFT);
    eval 'sub PTE_FILE_MAX_BITS () {( &BITS_PER_LONG -  &PTE_SHIFT);}' unless defined(&PTE_FILE_MAX_BITS);
    eval 'sub pte_to_pgoff {
        my($pte) = @_;
	    eval q(( &pte_val($pte) >>  &PTE_SHIFT));
    }' unless defined(&pte_to_pgoff);
    eval 'sub pgoff_to_pte {
        my($off) = @_;
	    eval q((( &pte_t) { (($off) <<  &PTE_SHIFT) |  &_PAGE_FILE }));
    }' unless defined(&pgoff_to_pte);
    eval 'sub _PAGE_READ () {(1<<  &xlate_pabit( &_PAGE_READ_BIT));}' unless defined(&_PAGE_READ);
    eval 'sub _PAGE_WRITE () {(1<<  &xlate_pabit( &_PAGE_WRITE_BIT));}' unless defined(&_PAGE_WRITE);
    eval 'sub _PAGE_RW () {( &_PAGE_READ |  &_PAGE_WRITE);}' unless defined(&_PAGE_RW);
    eval 'sub _PAGE_EXEC () {(1<<  &xlate_pabit( &_PAGE_EXEC_BIT));}' unless defined(&_PAGE_EXEC);
    eval 'sub _PAGE_GATEWAY () {(1<<  &xlate_pabit( &_PAGE_GATEWAY_BIT));}' unless defined(&_PAGE_GATEWAY);
    eval 'sub _PAGE_DMB () {(1<<  &xlate_pabit( &_PAGE_DMB_BIT));}' unless defined(&_PAGE_DMB);
    eval 'sub _PAGE_DIRTY () {(1<<  &xlate_pabit( &_PAGE_DIRTY_BIT));}' unless defined(&_PAGE_DIRTY);
    eval 'sub _PAGE_REFTRAP () {(1<<  &xlate_pabit( &_PAGE_REFTRAP_BIT));}' unless defined(&_PAGE_REFTRAP);
    eval 'sub _PAGE_NO_CACHE () {(1<<  &xlate_pabit( &_PAGE_NO_CACHE_BIT));}' unless defined(&_PAGE_NO_CACHE);
    eval 'sub _PAGE_ACCESSED () {(1<<  &xlate_pabit( &_PAGE_ACCESSED_BIT));}' unless defined(&_PAGE_ACCESSED);
    eval 'sub _PAGE_PRESENT () {(1<<  &xlate_pabit( &_PAGE_PRESENT_BIT));}' unless defined(&_PAGE_PRESENT);
    eval 'sub _PAGE_FLUSH () {(1<<  &xlate_pabit( &_PAGE_FLUSH_BIT));}' unless defined(&_PAGE_FLUSH);
    eval 'sub _PAGE_USER () {(1<<  &xlate_pabit( &_PAGE_USER_BIT));}' unless defined(&_PAGE_USER);
    eval 'sub _PAGE_FILE () {(1<<  &xlate_pabit( &_PAGE_FILE_BIT));}' unless defined(&_PAGE_FILE);
    eval 'sub _PAGE_TABLE () {( &_PAGE_PRESENT |  &_PAGE_READ |  &_PAGE_WRITE |  &_PAGE_DIRTY |  &_PAGE_ACCESSED);}' unless defined(&_PAGE_TABLE);
    eval 'sub _PAGE_CHG_MASK () {( &PAGE_MASK |  &_PAGE_ACCESSED |  &_PAGE_DIRTY);}' unless defined(&_PAGE_CHG_MASK);
    eval 'sub _PAGE_KERNEL () {( &_PAGE_PRESENT |  &_PAGE_EXEC |  &_PAGE_READ |  &_PAGE_WRITE |  &_PAGE_DIRTY |  &_PAGE_ACCESSED);}' unless defined(&_PAGE_KERNEL);
    eval 'sub _PxD_PRESENT_BIT () {31;}' unless defined(&_PxD_PRESENT_BIT);
    eval 'sub _PxD_ATTACHED_BIT () {30;}' unless defined(&_PxD_ATTACHED_BIT);
    eval 'sub _PxD_VALID_BIT () {29;}' unless defined(&_PxD_VALID_BIT);
    eval 'sub PxD_FLAG_PRESENT () {(1<<  &xlate_pabit( &_PxD_PRESENT_BIT));}' unless defined(&PxD_FLAG_PRESENT);
    eval 'sub PxD_FLAG_ATTACHED () {(1<<  &xlate_pabit( &_PxD_ATTACHED_BIT));}' unless defined(&PxD_FLAG_ATTACHED);
    eval 'sub PxD_FLAG_VALID () {(1<<  &xlate_pabit( &_PxD_VALID_BIT));}' unless defined(&PxD_FLAG_VALID);
    eval 'sub PxD_FLAG_MASK () {(0xf);}' unless defined(&PxD_FLAG_MASK);
    eval 'sub PxD_FLAG_SHIFT () {(4);}' unless defined(&PxD_FLAG_SHIFT);
    eval 'sub PxD_VALUE_SHIFT () {(8);}' unless defined(&PxD_VALUE_SHIFT);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub PAGE_NONE () { &__pgprot( &_PAGE_PRESENT |  &_PAGE_USER |  &_PAGE_ACCESSED);}' unless defined(&PAGE_NONE);
	eval 'sub PAGE_SHARED () { &__pgprot( &_PAGE_PRESENT |  &_PAGE_USER |  &_PAGE_READ |  &_PAGE_WRITE |  &_PAGE_ACCESSED);}' unless defined(&PAGE_SHARED);
	eval 'sub PAGE_READONLY () { &__pgprot( &_PAGE_PRESENT |  &_PAGE_USER |  &_PAGE_READ |  &_PAGE_ACCESSED);}' unless defined(&PAGE_READONLY);
	eval 'sub PAGE_WRITEONLY () { &__pgprot( &_PAGE_PRESENT |  &_PAGE_USER |  &_PAGE_WRITE |  &_PAGE_ACCESSED);}' unless defined(&PAGE_WRITEONLY);
	eval 'sub PAGE_EXECREAD () { &__pgprot( &_PAGE_PRESENT |  &_PAGE_USER |  &_PAGE_READ |  &_PAGE_EXEC | &_PAGE_ACCESSED);}' unless defined(&PAGE_EXECREAD);
	eval 'sub PAGE_COPY () { &PAGE_EXECREAD;}' unless defined(&PAGE_COPY);
	eval 'sub PAGE_RWX () { &__pgprot( &_PAGE_PRESENT |  &_PAGE_USER |  &_PAGE_READ |  &_PAGE_WRITE |  &_PAGE_EXEC | &_PAGE_ACCESSED);}' unless defined(&PAGE_RWX);
	eval 'sub PAGE_KERNEL () { &__pgprot( &_PAGE_KERNEL);}' unless defined(&PAGE_KERNEL);
	eval 'sub PAGE_KERNEL_RO () { &__pgprot( &_PAGE_PRESENT |  &_PAGE_EXEC |  &_PAGE_READ |  &_PAGE_DIRTY |  &_PAGE_ACCESSED);}' unless defined(&PAGE_KERNEL_RO);
	eval 'sub PAGE_KERNEL_UNC () { &__pgprot( &_PAGE_KERNEL |  &_PAGE_NO_CACHE);}' unless defined(&PAGE_KERNEL_UNC);
	eval 'sub PAGE_GATEWAY () { &__pgprot( &_PAGE_PRESENT |  &_PAGE_USER |  &_PAGE_ACCESSED |  &_PAGE_GATEWAY|  &_PAGE_READ);}' unless defined(&PAGE_GATEWAY);
	eval 'sub PAGE_FLUSH () { &__pgprot( &_PAGE_FLUSH);}' unless defined(&PAGE_FLUSH);
	eval 'sub __P000 () { &PAGE_NONE;}' unless defined(&__P000);
	eval 'sub __P001 () { &PAGE_READONLY;}' unless defined(&__P001);
	eval 'sub __P010 () { &__P000;}' unless defined(&__P010);
	eval 'sub __P011 () { &__P001;}' unless defined(&__P011);
	eval 'sub __P100 () { &PAGE_EXECREAD;}' unless defined(&__P100);
	eval 'sub __P101 () { &PAGE_EXECREAD;}' unless defined(&__P101);
	eval 'sub __P110 () { &__P100;}' unless defined(&__P110);
	eval 'sub __P111 () { &__P101;}' unless defined(&__P111);
	eval 'sub __S000 () { &PAGE_NONE;}' unless defined(&__S000);
	eval 'sub __S001 () { &PAGE_READONLY;}' unless defined(&__S001);
	eval 'sub __S010 () { &PAGE_WRITEONLY;}' unless defined(&__S010);
	eval 'sub __S011 () { &PAGE_SHARED;}' unless defined(&__S011);
	eval 'sub __S100 () { &PAGE_EXECREAD;}' unless defined(&__S100);
	eval 'sub __S101 () { &PAGE_EXECREAD;}' unless defined(&__S101);
	eval 'sub __S110 () { &PAGE_RWX;}' unless defined(&__S110);
	eval 'sub __S111 () { &PAGE_RWX;}' unless defined(&__S111);
	eval 'sub ZERO_PAGE {
	    my($vaddr) = @_;
    	    eval q(( &virt_to_page( &empty_zero_page)));
	}' unless defined(&ZERO_PAGE);
	eval 'sub pte_none {
	    my($x) = @_;
    	    eval q((( &pte_val($x) == 0) || ( &pte_val($x) &  &_PAGE_FLUSH)));
	}' unless defined(&pte_none);
	eval 'sub pte_present {
	    my($x) = @_;
    	    eval q(( &pte_val($x) &  &_PAGE_PRESENT));
	}' unless defined(&pte_present);
	eval 'sub pte_clear {
	    my($xp) = @_;
    	    eval q( &do {  &pte_val(*($xp)) = 0; }  &while (0));
	}' unless defined(&pte_clear);
	eval 'sub pmd_flag {
	    my($x) = @_;
    	    eval q(( &pmd_val($x) &  &PxD_FLAG_MASK));
	}' unless defined(&pmd_flag);
	eval 'sub pmd_address {
	    my($x) = @_;
    	    eval q((( &pmd_val($x) &~  &PxD_FLAG_MASK) <<  &PxD_VALUE_SHIFT));
	}' unless defined(&pmd_address);
	eval 'sub pgd_flag {
	    my($x) = @_;
    	    eval q(( &pgd_val($x) &  &PxD_FLAG_MASK));
	}' unless defined(&pgd_flag);
	eval 'sub pgd_address {
	    my($x) = @_;
    	    eval q((( &pgd_val($x) &~  &PxD_FLAG_MASK) <<  &PxD_VALUE_SHIFT));
	}' unless defined(&pgd_address);
	if(defined(&CONFIG_64BIT)) {
	    eval 'sub pmd_none {
	        my($x) = @_;
    		eval q((! &pmd_val($x) ||  &pmd_flag($x) ==  &PxD_FLAG_ATTACHED));
	    }' unless defined(&pmd_none);
	} else {
	    eval 'sub pmd_none {
	        my($x) = @_;
    		eval q((! &pmd_val($x)));
	    }' unless defined(&pmd_none);
	}
	eval 'sub pmd_bad {
	    my($x) = @_;
    	    eval q((!( &pmd_flag($x) &  &PxD_FLAG_VALID)));
	}' unless defined(&pmd_bad);
	eval 'sub pmd_present {
	    my($x) = @_;
    	    eval q(( &pmd_flag($x) &  &PxD_FLAG_PRESENT));
	}' unless defined(&pmd_present);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub pmd_clear {
	    my($pmd) = @_;
    	    eval q({  &__pmd_val_set(*$pmd, 0); });
	}' unless defined(&pmd_clear);
	if((defined(&PT_NLEVELS) ? &PT_NLEVELS : 0) == 3) {
	    eval 'sub pgd_page {
	        my($pgd) = @_;
    		eval q((  &__va( &pgd_address($pgd))));
	    }' unless defined(&pgd_page);
	    eval 'sub pgd_none {
	        my($x) = @_;
    		eval q((! &pgd_val($x)));
	    }' unless defined(&pgd_none);
	    eval 'sub pgd_bad {
	        my($x) = @_;
    		eval q((!( &pgd_flag($x) &  &PxD_FLAG_VALID)));
	    }' unless defined(&pgd_bad);
	    eval 'sub pgd_present {
	        my($x) = @_;
    		eval q(( &pgd_flag($x) &  &PxD_FLAG_PRESENT));
	    }' unless defined(&pgd_present);
# some #ifdef were dropped here -- fill in the blanks
	    eval 'sub pgd_clear {
	        my($pgd) = @_;
    		eval q({  &__pgd_val_set(*$pgd, 0); });
	    }' unless defined(&pgd_clear);
	} else {
	    eval 'sub mk_pte {
	        my($page, $pgprot) = @_;
    		eval q( &pfn_pte( &page_to_pfn($page), ($pgprot)));
	    }' unless defined(&mk_pte);
	    eval 'sub pfn_pte {
	        my($pfn,$pgprot) = @_;
    		eval q({  &pte_t  &pte;  &pte_val( &pte) = ($pfn <<  &PAGE_SHIFT) |  &pgprot_val($pgprot);  &pte; });
	    }' unless defined(&pfn_pte);
	    eval 'sub mk_pte_phys {
	        my($physpage, $pgprot) = @_;
    		eval q(({  &pte_t  &__pte;  &pte_val( &__pte) = $physpage +  &pgprot_val($pgprot);  &__pte; }));
	    }' unless defined(&mk_pte_phys);
# some #ifdef were dropped here -- fill in the blanks
	    eval 'sub ptep_test_and_clear_dirty {
	        my($ptep) = @_;
    		eval q({ });
	    }' unless defined(&ptep_test_and_clear_dirty);
	    eval 'sub ptep_get_and_clear {
	        my($ptep) = @_;
    		eval q({  &pte_t  &old_pte;  &pte_t  &pte;  &spin_lock( &pa_dbit_lock);  &pte =  &old_pte = *$ptep;  &pte_val( &pte) &= ~ &_PAGE_PRESENT;  &pte_val( &pte) |=  &_PAGE_FLUSH;  &set_pte($ptep, &pte);  &spin_unlock( &pa_dbit_lock);  &old_pte; });
	    }' unless defined(&ptep_get_and_clear);
# some #ifdef were dropped here -- fill in the blanks
	    eval 'sub ptep_set_wrprotect {
	        my($ptep) = @_;
    		eval q({ });
	    }' unless defined(&ptep_set_wrprotect);
# some #ifdef were dropped here -- fill in the blanks
	    eval 'sub ptep_mkdirty {
	        my($ptep) = @_;
    		eval q({ });
	    }' unless defined(&ptep_mkdirty);
	    eval 'sub pte_same {
	        my($A,$B) = @_;
    		eval q(( &pte_val($A) ==  &pte_val($B)));
	    }' unless defined(&pte_same);
	}
	eval 'sub io_remap_page_range {
	    my($vma, $vaddr, $paddr, $size, $prot) = @_;
    	    eval q( &remap_pfn_range($vma, $vaddr, ($paddr) >>  &PAGE_SHIFT, $size, $prot));
	}' unless defined(&io_remap_page_range);
	eval 'sub HAVE_ARCH_UNMAPPED_AREA () {1;}' unless defined(&HAVE_ARCH_UNMAPPED_AREA);
	eval 'sub __HAVE_ARCH_PTEP_TEST_AND_CLEAR_YOUNG () {1;}' unless defined(&__HAVE_ARCH_PTEP_TEST_AND_CLEAR_YOUNG);
	eval 'sub __HAVE_ARCH_PTEP_TEST_AND_CLEAR_DIRTY () {1;}' unless defined(&__HAVE_ARCH_PTEP_TEST_AND_CLEAR_DIRTY);
	eval 'sub __HAVE_ARCH_PTEP_GET_AND_CLEAR () {1;}' unless defined(&__HAVE_ARCH_PTEP_GET_AND_CLEAR);
	eval 'sub __HAVE_ARCH_PTEP_SET_WRPROTECT () {1;}' unless defined(&__HAVE_ARCH_PTEP_SET_WRPROTECT);
	eval 'sub __HAVE_ARCH_PTEP_MKDIRTY () {1;}' unless defined(&__HAVE_ARCH_PTEP_MKDIRTY);
	eval 'sub __HAVE_ARCH_PTE_SAME () {1;}' unless defined(&__HAVE_ARCH_PTE_SAME);
	require 'asm-generic/pgtable.ph';
    }
1;
