require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_IP6_TABLES_H)) {
    eval 'sub _IP6_TABLES_H () {1;}' unless defined(&_IP6_TABLES_H);
    if(defined(&__KERNEL__)) {
	require 'linux/if.ph';
	require 'linux/types.ph';
	require 'linux/in6.ph';
	require 'linux/ipv6.ph';
	require 'linux/skbuff.ph';
    }
    require 'linux/compiler.ph';
    require 'linux/netfilter_ipv6.ph';
    eval 'sub IP6T_FUNCTION_MAXNAMELEN () {30;}' unless defined(&IP6T_FUNCTION_MAXNAMELEN);
    eval 'sub IP6T_TABLE_MAXNAMELEN () {32;}' unless defined(&IP6T_TABLE_MAXNAMELEN);
    eval 'sub IP6T_F_PROTO () {0x1;}' unless defined(&IP6T_F_PROTO);
    eval 'sub IP6T_F_TOS () {0x2;}' unless defined(&IP6T_F_TOS);
    eval 'sub IP6T_F_MASK () {0x3;}' unless defined(&IP6T_F_MASK);
    eval 'sub IP6T_INV_VIA_IN () {0x1;}' unless defined(&IP6T_INV_VIA_IN);
    eval 'sub IP6T_INV_VIA_OUT () {0x2;}' unless defined(&IP6T_INV_VIA_OUT);
    eval 'sub IP6T_INV_TOS () {0x4;}' unless defined(&IP6T_INV_TOS);
    eval 'sub IP6T_INV_SRCIP () {0x8;}' unless defined(&IP6T_INV_SRCIP);
    eval 'sub IP6T_INV_DSTIP () {0x10;}' unless defined(&IP6T_INV_DSTIP);
    eval 'sub IP6T_INV_FRAG () {0x20;}' unless defined(&IP6T_INV_FRAG);
    eval 'sub IP6T_INV_PROTO () {0x40;}' unless defined(&IP6T_INV_PROTO);
    eval 'sub IP6T_INV_MASK () {0x7f;}' unless defined(&IP6T_INV_MASK);
    eval 'sub IP6T_BASE_CTL () {64;}' unless defined(&IP6T_BASE_CTL);
    eval 'sub IP6T_SO_SET_REPLACE () {( &IP6T_BASE_CTL);}' unless defined(&IP6T_SO_SET_REPLACE);
    eval 'sub IP6T_SO_SET_ADD_COUNTERS () {( &IP6T_BASE_CTL + 1);}' unless defined(&IP6T_SO_SET_ADD_COUNTERS);
    eval 'sub IP6T_SO_SET_MAX () { &IP6T_SO_SET_ADD_COUNTERS;}' unless defined(&IP6T_SO_SET_MAX);
    eval 'sub IP6T_SO_GET_INFO () {( &IP6T_BASE_CTL);}' unless defined(&IP6T_SO_GET_INFO);
    eval 'sub IP6T_SO_GET_ENTRIES () {( &IP6T_BASE_CTL + 1);}' unless defined(&IP6T_SO_GET_ENTRIES);
    eval 'sub IP6T_SO_GET_MAX () { &IP6T_SO_GET_ENTRIES;}' unless defined(&IP6T_SO_GET_MAX);
    eval 'sub IP6T_CONTINUE () {0xffffffff;}' unless defined(&IP6T_CONTINUE);
    eval 'sub IP6T_RETURN () {(- &NF_MAX_VERDICT - 1);}' unless defined(&IP6T_RETURN);
    eval 'sub IP6T_TCP_INV_SRCPT () {0x1;}' unless defined(&IP6T_TCP_INV_SRCPT);
    eval 'sub IP6T_TCP_INV_DSTPT () {0x2;}' unless defined(&IP6T_TCP_INV_DSTPT);
    eval 'sub IP6T_TCP_INV_FLAGS () {0x4;}' unless defined(&IP6T_TCP_INV_FLAGS);
    eval 'sub IP6T_TCP_INV_OPTION () {0x8;}' unless defined(&IP6T_TCP_INV_OPTION);
    eval 'sub IP6T_TCP_INV_MASK () {0xf;}' unless defined(&IP6T_TCP_INV_MASK);
    eval 'sub IP6T_UDP_INV_SRCPT () {0x1;}' unless defined(&IP6T_UDP_INV_SRCPT);
    eval 'sub IP6T_UDP_INV_DSTPT () {0x2;}' unless defined(&IP6T_UDP_INV_DSTPT);
    eval 'sub IP6T_UDP_INV_MASK () {0x3;}' unless defined(&IP6T_UDP_INV_MASK);
    eval 'sub IP6T_ICMP_INV () {0x1;}' unless defined(&IP6T_ICMP_INV);
    eval 'sub IP6T_STANDARD_TARGET () {"";}' unless defined(&IP6T_STANDARD_TARGET);
    eval 'sub IP6T_ERROR_TARGET () {"ERROR";}' unless defined(&IP6T_ERROR_TARGET);
    eval 'sub IP6T_MATCH_ITERATE () {( &e,  &fn,  &args...) ({ \'unsigned int __i\'; \'int\'  &__ret = 0; \'struct ip6t_entry_match\' * &__m;  &for ( &__i = $sizeof{\'struct ip6t_entry\'};  &__i < ( &e)-> &target_offset;  &__i +=  ($__m->{u}->{match_size})) {  &__m = ( &void *)( &e) +  &__i;  &__ret =  &fn( &__m ,   &args);  &if ( &__ret != 0)  &break; }  &__ret; });}' unless defined(&IP6T_MATCH_ITERATE);
    eval 'sub IP6T_ENTRY_ITERATE () {( &entries,  &size,  &fn,  &args...) ({ \'unsigned int __i\'; \'int\'  &__ret = 0; \'struct ip6t_entry\' * &__e;  &for ( &__i = 0;  &__i < ( &size);  &__i +=  ($__e->{next_offset})) {  &__e = ( &void *)( &entries) +  &__i;  &__ret =  &fn( &__e ,   &args);  &if ( &__ret != 0)  &break; }  &__ret; });}' unless defined(&IP6T_ENTRY_ITERATE);
    if(defined(&__KERNEL__)) {
	require 'linux/init.ph';
	eval 'sub IP6T_ALIGN {
	    my($s) = @_;
    	    eval q(((($s) + ( &__alignof__-1)) & ~( &__alignof__-1)));
	}' unless defined(&IP6T_ALIGN);
    }
}
1;
